# PhasicFlow: src/phasicFlow/types/basicTypes/math.hpp File Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

math.hpp File Reference
Include dependency graph for math.hpp:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Namespaces

| pFlow

## Functions

INLINE_FUNCTION_HD real | abs (real x)
INLINE_FUNCTION_HD int64 | abs (int64 x)
INLINE_FUNCTION_HD int32 | abs (int32 x)
INLINE_FUNCTION_HD real | mod (real x, real y)
INLINE_FUNCTION_HD int64 | mod (int64 x, int64 y)
INLINE_FUNCTION_HD int32 | mod (int32 x, int32 y)
INLINE_FUNCTION_HD int64 | mod (uint64 x, uint64 y)
INLINE_FUNCTION_HD auto | mod (uint32 x, uint32 y)
INLINE_FUNCTION_HD real | remainder (real x, real y)
INLINE_FUNCTION_HD real | exp (real x)
INLINE_FUNCTION_HD real | log (real x)
INLINE_FUNCTION_HD real | log10 (real x)
INLINE_FUNCTION_HD real | pow (real x, real y)
INLINE_FUNCTION_HD real | sqrt (real x)
INLINE_FUNCTION_HD real | cbrt (real x)
INLINE_FUNCTION_HD real | sin (real x)
INLINE_FUNCTION_HD real | cos (real x)
INLINE_FUNCTION_HD real | tan (real x)
INLINE_FUNCTION_HD real | asin (real x)
INLINE_FUNCTION_HD real | acos (real x)
INLINE_FUNCTION_HD real | atan (real x)
INLINE_FUNCTION_HD real | atan2 (real y, real x)
INLINE_FUNCTION_HD real | sinh (real x)
INLINE_FUNCTION_HD real | cosh (real x)
INLINE_FUNCTION_HD real | tanh (real x)
INLINE_FUNCTION_HD real | asinh (real x)
INLINE_FUNCTION_HD real | acosh (real x)
INLINE_FUNCTION_HD real | atanh (real x)
INLINE_FUNCTION_HD real | min (real x, real y)
INLINE_FUNCTION_HD int64 | min (int32 x, int32 y)
INLINE_FUNCTION_HD int64 | min (int64 x, int64 y)
INLINE_FUNCTION_HD uint64 | min (uint64 x, uint64 y)
INLINE_FUNCTION_HD uint32 | min (uint32 x, uint32 y)
INLINE_FUNCTION_HD real | max (real x, real y)
INLINE_FUNCTION_HD int64 | max (int64 x, int64 y)
INLINE_FUNCTION_HD int32 | max (int32 x, int32 y)
INLINE_FUNCTION_HD uint64 | max (uint64 x, uint64 y)
INLINE_FUNCTION_HD uint32 | max (uint32 x, uint32 y)